---
title: WebGLRenderingContext.readPixels()
slug: Web/API/WebGLRenderingContext/readPixels
tags:
  - API
  - Method
  - Reference
  - WebGL
  - WebGLRenderingContext
---
<div>{{APIRef("WebGL")}}</div>

<p>The <strong><code>WebGLRenderingContext.readPixels()</code></strong> method of the <a href="/en-US/docs/Web/API/WebGL_API">WebGL API</a> reads a block of pixels from a specified rectangle of the current color framebuffer into an {{domxref("ArrayBufferView")}} object.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">// WebGL1:
void gl.readPixels(x, y, width, height, format, type, pixels);

// WebGL2:
void gl.readPixels(x, y, width, height, format, type, GLintptr offset);
void gl.readPixels(x, y, width, height, format, type, ArrayBufferView pixels, GLuint dstOffset);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt>x</dt>
 <dd>A {{domxref("GLint")}} specifying the first horizontal pixel that is read from the lower left corner of a rectangular block of pixels.</dd>
 <dt>y</dt>
 <dd>A {{domxref("GLint")}} specifying the first vertical pixel that is read from the lower left corner of a rectangular block of pixels.</dd>
 <dt>width</dt>
 <dd>A {{domxref("GLsizei")}} specifying the width of the rectangle.</dd>
 <dt>height</dt>
 <dd>A {{domxref("GLsizei")}} specifying the height of the rectangle.</dd>
 <dt>format</dt>
 <dd>A {{domxref("GLenum")}} specifying the format of the pixel data. Possible values:
 <ul>
  <li><code>gl.ALPHA</code>: Discards the red, green and blue components and reads the alpha component.</li>
  <li><code>gl.RGB</code>: Discards the alpha components and reads the red, green and blue components.</li>
  <li><code>gl.RGBA</code>: Red, green, blue and alpha components are read from the color buffer.</li>
 </ul>

 <p>WebGL2 adds</p>

 <ul>
  <li><font face="consolas, Liberation Mono, courier, monospace"><span style="background-color: rgba(220, 220, 220, 0.5);">gl.RED</span></font></li>
  <li><font face="consolas, Liberation Mono, courier, monospace"><span style="background-color: rgba(220, 220, 220, 0.5);">gl.RG</span></font></li>
  <li><font face="consolas, Liberation Mono, courier, monospace"><span style="background-color: rgba(220, 220, 220, 0.5);">gl.RED_INTEGER</span></font></li>
  <li><font face="consolas, Liberation Mono, courier, monospace"><span style="background-color: rgba(220, 220, 220, 0.5);">gl.RG_INTEGER</span></font></li>
  <li><font face="consolas, Liberation Mono, courier, monospace"><span style="background-color: rgba(220, 220, 220, 0.5);">gl.RGB_INTEGER</span></font></li>
  <li><font face="consolas, Liberation Mono, courier, monospace"><span style="background-color: rgba(220, 220, 220, 0.5);">gl.RGBA_INTEGER</span></font></li>
 </ul>
 </dd>
 <dt>type</dt>
 <dd>A {{domxref("GLenum")}} specifying the data type of the pixel data. Possible values:
 <ul>
  <li><code>gl.UNSIGNED_BYTE</code></li>
  <li><code>gl.UNSIGNED_SHORT_5_6_5</code></li>
  <li><code>gl.UNSIGNED_SHORT_4_4_4_4</code></li>
  <li><code>gl.UNSIGNED_SHORT_5_5_5_1</code></li>
  <li><code>gl.FLOAT</code></li>
 </ul>

 <p>WebGL2 adds</p>

 <ul>
  <li><code>gl.BYTE</code></li>
  <li><code>gl.UNSIGNED_INT_2_10_10_10_REV</code></li>
  <li><code>gl.HALF_FLOAT</code></li>
  <li><code>gl.SHORT</code></li>
  <li><code>gl.UNSIGNED_SHORT</code></li>
  <li><code>gl.INT</code></li>
  <li><code>gl.UNSIGNED_INT</code></li>
  <li><font face="consolas, Liberation Mono, courier, monospace"><span style="background-color: rgba(220, 220, 220, 0.5);">gl.UNSIGNED_INT_10F_11F_11F_REV</span></font></li>
  <li><font face="consolas, Liberation Mono, courier, monospace"><span style="background-color: rgba(220, 220, 220, 0.5);">gl.UNSIGNED_INT_5_9_9_9_REV</span></font></li>
 </ul>
 </dd>
 <dt>pixels</dt>
 <dd>An {{domxref("ArrayBufferView")}} object to read data into. The array type must match the type of the <code>type</code> parameter.
 <ul>
  <li>{{jsxref("Uint8Array")}} for <code>gl.UNSIGNED_BYTE</code>.</li>
  <li>{{jsxref("Uint16Array")}} for <code>gl.UNSIGNED_SHORT_5_6_5</code>, <code>gl.UNSIGNED_SHORT_4_4_4_4</code>, or <code>gl.UNSIGNED_SHORT_5_5_5_1</code>.</li>
  <li>{{jsxref("Float32Array")}} for <code>gl.FLOAT</code>.</li>
 </ul>
 </dd>
 <dt><code>dstOffset</code> {{optional_inline}}</dt>
 <dd>Offset. Defaults to 0.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>None.</p>

<h3 id="Exceptions">Exceptions</h3>

<ul>
 <li>A <code>gl.INVALID_ENUM</code> error is thrown if <code>format</code> or <code>type</code> is not an accepted value.</li>
 <li>A <code>gl.INVALID_OPERATION</code> error is thrown if
  <ul>
   <li><code>type</code> is <code>gl.UNSIGNED_SHORT_5_6_5</code> and <code>format</code> is not <code>gl.RGB</code>.</li>
   <li><code>type</code> is <code>gl.UNSIGNED_SHORT_4_4_4_4</code> and <code>format</code> is not <code>gl.RGB</code>A.</li>
   <li><code>type</code> does not match the typed array type of <code>pixels</code>.</li>
  </ul>
 </li>
 <li>A <code>gl.INVALID_FRAMEBUFFER_OPERATION</code> error is thrown if the currently bound framebuffer is not framebuffer complete.</li>
</ul>

<h2 id="Examples">Examples</h2>

<pre class="brush: js">var canvas = document.getElementById('canvas');
var gl = canvas.getContext('webgl');
var pixels = new Uint8Array(gl.drawingBufferWidth * gl.drawingBufferHeight * 4);
gl.readPixels(0, 0, gl.drawingBufferWidth, gl.drawingBufferHeight, gl.RGBA, gl.UNSIGNED_BYTE, pixels);
console.log(pixels); // Uint8Array
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('WebGL', "#5.14.12", "readPixels")}}</td>
   <td>{{Spec2('WebGL')}}</td>
   <td>Initial definition.</td>
  </tr>
  <tr>
   <td>{{SpecName('OpenGL ES 2.0', "glReadPixels.xml", "glReadPixels")}}</td>
   <td>{{Spec2('OpenGL ES 2.0')}}</td>
   <td>Man page of the OpenGL API.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p class="hidden">The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>

<p>{{Compat("api.WebGLRenderingContext.readPixels")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/JavaScript/Typed_arrays">Typed Arrays</a></li>
</ul>
